package k4unl.minecraft.k4lib.lib;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.util.IChatComponent;

/*
Simple inventory implementation for use in Tile Entities, anywhere really
*/
public class SimpleInventory implements IInventory {
    protected final ItemStack[] inventory;
    protected final String inventoryName;
    protected final int inventoryLimit;
    protected Container owner;

    public SimpleInventory(int slots, String inventoryName, int inventoryLimit, Container container) {
        this.inventoryName = inventoryName;
        this.inventoryLimit = inventoryLimit;
        inventory = new ItemStack[slots];
        this.owner = container;
    }

    public SimpleInventory(int slots, String inventoryName, int inventoryLimit) {
        this.inventoryName = inventoryName;
        this.inventoryLimit = inventoryLimit;
        inventory = new ItemStack[slots];
    }

    public SimpleInventory(int slots) {
        this.inventoryName = "";
        this.inventoryLimit = 64;
        this.inventory = new ItemStack[slots];
    }

    public Container getContainer() {
        return this.owner;
    }

    public void setContainer(Container container) {
        this.owner = container;
    }

    @Override
    public int func_70302_i_() {
        return inventory.length;
    }

    @Override
    public ItemStack func_70301_a(int slot) {
        if (slot >= inventory.length)
            return null;

        return inventory[slot];
    }

    @Override
    public ItemStack func_70298_a(int slot, int amount) {
        ItemStack stack = null;

        if (inventory[slot] != null) {
            if (inventory[slot].field_77994_a <= amount) {
                stack = inventory[slot];
                inventory[slot] = null;
            } else {
                stack = inventory[slot].func_77979_a(amount);
                if (inventory[slot].field_77994_a == 0) {
                    inventory[slot] = null;
                }
            }
        }

        return stack;
    }

    @Override
    public ItemStack func_70304_b(int slot) {
        ItemStack items = func_70301_a(slot);
        if (items != null)
            func_70299_a(slot, null);

        return items;
    }

    @Override
    public void func_70299_a(int slot, ItemStack item) {
        inventory[slot] = item;
    }

    @Override
    public int func_70297_j_() {
        return inventoryLimit;
    }

    @Override
    public void func_70296_d() {

    }

    //TODO: Implement me
    @Override
    public boolean func_70300_a(EntityPlayer player) {
        return true;
    }

    //TODO: Implement me
    @Override
    public void func_174889_b(EntityPlayer playerIn) {

    }

    //TODO: Implement me
    @Override
    public void func_174886_c(EntityPlayer playerIn) {

    }

    //TODO: Implement me
    @Override
    public boolean func_94041_b(int p_94041_1_, ItemStack p_94041_2_) {
        return false;
    }

    //TODO: Implement me
    @Override
    public int func_174887_a_(int id) {
        return 0;
    }

    //TODO: Implement me
    @Override
    public void func_174885_b(int id, int value) {

    }

    //TODO: Implement me
    @Override
    public int func_174890_g() {
        return 0;
    }

    //TODO: Implement me
    @Override
    public void func_174888_l() {

    }

    public void load(NBTTagCompound nbt) {
        NBTTagList list = nbt.func_150295_c("Inventory", 10);
        for (int i = 0; i < list.func_74745_c(); i++) {
            NBTTagCompound tag = list.func_150305_b(i);
            byte slot = tag.func_74771_c("Slot");
            if (slot >= 0 && slot < inventory.length) {
                if (tag.func_74767_n("Empty"))
                    inventory[slot] = null;
                else
                    inventory[slot] = ItemStack.func_77949_a(tag);
            }
        }
    }

    public void save(NBTTagCompound nbt) {
        NBTTagList itemList = new NBTTagList();
        for (int i = 0; i < inventory.length; i++) {
            ItemStack stack = inventory[i];
            if (stack != null) {
                NBTTagCompound tag = new NBTTagCompound();
                tag.func_74774_a("Slot", (byte) i);
                stack.func_77955_b(tag);
                itemList.func_74742_a(tag);
            } else {
                NBTTagCompound tag = new NBTTagCompound();
                tag.func_74774_a("Slot", (byte) i);
                tag.func_74757_a("Empty", true);
                itemList.func_74742_a(tag);
            }
        }
        nbt.func_74782_a("Inventory", itemList);
    }

    //TODO: Implement me
    @Override
    public String func_70005_c_() {
        return null;
    }

    //TODO: Implement me
    @Override
    public boolean func_145818_k_() {
        return false;
    }

    //TODO: Implement me
    @Override
    public IChatComponent func_145748_c_() {
        return null;
    }
}
